<?php

namespace App|C\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PartnerIssuanceInfo StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:PartnerIssuanceInfo
 * @subpackage Structs
 */
class PartnerIssuanceInfo extends ApiObject
{
    /**
     * The PartnerAirlineDesignator
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $PartnerAirlineDesignator;
    /**
     * The PartnerPnrCode
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $PartnerPnrCode;
    /**
     * The RCIAirlineDesignator
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $RCIAirlineDesignator;
    /**
     * The RCIPartnerPnrCode
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $RCIPartnerPnrCode;
    /**
     * Constructor method for PartnerIssuanceInfo
     * @uses PartnerIssuanceInfo::setPartnerAirlineDesignator()
     * @uses PartnerIssuanceInfo::setPartnerPnrCode()
     * @uses PartnerIssuanceInfo::setRCIAirlineDesignator()
     * @uses PartnerIssuanceInfo::setRCIPartnerPnrCode()
     * @param string $partnerAirlineDesignator
     * @param string $partnerPnrCode
     * @param string $rCIAirlineDesignator
     * @param string $rCIPartnerPnrCode
     */
    public function __construct($partnerAirlineDesignator = null, $partnerPnrCode = null, $rCIAirlineDesignator = null, $rCIPartnerPnrCode = null)
    {
        $this
            ->setPartnerAirlineDesignator($partnerAirlineDesignator)
            ->setPartnerPnrCode($partnerPnrCode)
            ->setRCIAirlineDesignator($rCIAirlineDesignator)
            ->setRCIPartnerPnrCode($rCIPartnerPnrCode);
    }
    /**
     * Get PartnerAirlineDesignator value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getPartnerAirlineDesignator()
    {
        return isset($this->PartnerAirlineDesignator) ? $this->PartnerAirlineDesignator : null;
    }
    /**
     * Set PartnerAirlineDesignator value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $partnerAirlineDesignator
     * @return \App|C\StructType\PartnerIssuanceInfo
     */
    public function setPartnerAirlineDesignator($partnerAirlineDesignator = null)
    {
        // validation for constraint: string
        if (!is_null($partnerAirlineDesignator) && !is_string($partnerAirlineDesignator)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($partnerAirlineDesignator, true), gettype($partnerAirlineDesignator)), __LINE__);
        }
        if (is_null($partnerAirlineDesignator) || (is_array($partnerAirlineDesignator) && empty($partnerAirlineDesignator))) {
            unset($this->PartnerAirlineDesignator);
        } else {
            $this->PartnerAirlineDesignator = $partnerAirlineDesignator;
        }
        return $this;
    }
    /**
     * Get PartnerPnrCode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getPartnerPnrCode()
    {
        return isset($this->PartnerPnrCode) ? $this->PartnerPnrCode : null;
    }
    /**
     * Set PartnerPnrCode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $partnerPnrCode
     * @return \App|C\StructType\PartnerIssuanceInfo
     */
    public function setPartnerPnrCode($partnerPnrCode = null)
    {
        // validation for constraint: string
        if (!is_null($partnerPnrCode) && !is_string($partnerPnrCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($partnerPnrCode, true), gettype($partnerPnrCode)), __LINE__);
        }
        if (is_null($partnerPnrCode) || (is_array($partnerPnrCode) && empty($partnerPnrCode))) {
            unset($this->PartnerPnrCode);
        } else {
            $this->PartnerPnrCode = $partnerPnrCode;
        }
        return $this;
    }
    /**
     * Get RCIAirlineDesignator value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getRCIAirlineDesignator()
    {
        return isset($this->RCIAirlineDesignator) ? $this->RCIAirlineDesignator : null;
    }
    /**
     * Set RCIAirlineDesignator value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $rCIAirlineDesignator
     * @return \App|C\StructType\PartnerIssuanceInfo
     */
    public function setRCIAirlineDesignator($rCIAirlineDesignator = null)
    {
        // validation for constraint: string
        if (!is_null($rCIAirlineDesignator) && !is_string($rCIAirlineDesignator)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($rCIAirlineDesignator, true), gettype($rCIAirlineDesignator)), __LINE__);
        }
        if (is_null($rCIAirlineDesignator) || (is_array($rCIAirlineDesignator) && empty($rCIAirlineDesignator))) {
            unset($this->RCIAirlineDesignator);
        } else {
            $this->RCIAirlineDesignator = $rCIAirlineDesignator;
        }
        return $this;
    }
    /**
     * Get RCIPartnerPnrCode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getRCIPartnerPnrCode()
    {
        return isset($this->RCIPartnerPnrCode) ? $this->RCIPartnerPnrCode : null;
    }
    /**
     * Set RCIPartnerPnrCode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $rCIPartnerPnrCode
     * @return \App|C\StructType\PartnerIssuanceInfo
     */
    public function setRCIPartnerPnrCode($rCIPartnerPnrCode = null)
    {
        // validation for constraint: string
        if (!is_null($rCIPartnerPnrCode) && !is_string($rCIPartnerPnrCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($rCIPartnerPnrCode, true), gettype($rCIPartnerPnrCode)), __LINE__);
        }
        if (is_null($rCIPartnerPnrCode) || (is_array($rCIPartnerPnrCode) && empty($rCIPartnerPnrCode))) {
            unset($this->RCIPartnerPnrCode);
        } else {
            $this->RCIPartnerPnrCode = $rCIPartnerPnrCode;
        }
        return $this;
    }
}
