<?php

namespace App|C\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for TicketAmountDetails StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:TicketAmountDetails
 * @subpackage Structs
 */
class TicketAmountDetails extends AmountDetails
{
    /**
     * The BaseCurrencyCode
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $BaseCurrencyCode;
    /**
     * The CurrencyRates
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\CurrencyRates
     */
    public $CurrencyRates;
    /**
     * The FareCalculation
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $FareCalculation;
    /**
     * The FareCurrencyCode
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $FareCurrencyCode;
    /**
     * The Endorsement
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Endorsement;
    /**
     * The HasBaseCurrency
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $HasBaseCurrency;
    /**
     * The HasNUCCurrency
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $HasNUCCurrency;
    /**
     * The AdditionalCollectionInfo
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\AdditionalCollectionInfo
     */
    public $AdditionalCollectionInfo;
    /**
     * Constructor method for TicketAmountDetails
     * @uses TicketAmountDetails::setBaseCurrencyCode()
     * @uses TicketAmountDetails::setCurrencyRates()
     * @uses TicketAmountDetails::setFareCalculation()
     * @uses TicketAmountDetails::setFareCurrencyCode()
     * @uses TicketAmountDetails::setEndorsement()
     * @uses TicketAmountDetails::setHasBaseCurrency()
     * @uses TicketAmountDetails::setHasNUCCurrency()
     * @uses TicketAmountDetails::setAdditionalCollectionInfo()
     * @param string $baseCurrencyCode
     * @param \App|C\StructType\CurrencyRates $currencyRates
     * @param string $fareCalculation
     * @param string $fareCurrencyCode
     * @param string $endorsement
     * @param bool $hasBaseCurrency
     * @param bool $hasNUCCurrency
     * @param \App|C\StructType\AdditionalCollectionInfo $additionalCollectionInfo
     */
    public function __construct($baseCurrencyCode = null, \App|C\StructType\CurrencyRates $currencyRates = null, $fareCalculation = null, $fareCurrencyCode = null, $endorsement = null, $hasBaseCurrency = null, $hasNUCCurrency = null, \App|C\StructType\AdditionalCollectionInfo $additionalCollectionInfo = null)
    {
        $this
            ->setBaseCurrencyCode($baseCurrencyCode)
            ->setCurrencyRates($currencyRates)
            ->setFareCalculation($fareCalculation)
            ->setFareCurrencyCode($fareCurrencyCode)
            ->setEndorsement($endorsement)
            ->setHasBaseCurrency($hasBaseCurrency)
            ->setHasNUCCurrency($hasNUCCurrency)
            ->setAdditionalCollectionInfo($additionalCollectionInfo);
    }
    /**
     * Get BaseCurrencyCode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getBaseCurrencyCode()
    {
        return isset($this->BaseCurrencyCode) ? $this->BaseCurrencyCode : null;
    }
    /**
     * Set BaseCurrencyCode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $baseCurrencyCode
     * @return \App|C\StructType\TicketAmountDetails
     */
    public function setBaseCurrencyCode($baseCurrencyCode = null)
    {
        // validation for constraint: string
        if (!is_null($baseCurrencyCode) && !is_string($baseCurrencyCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($baseCurrencyCode, true), gettype($baseCurrencyCode)), __LINE__);
        }
        if (is_null($baseCurrencyCode) || (is_array($baseCurrencyCode) && empty($baseCurrencyCode))) {
            unset($this->BaseCurrencyCode);
        } else {
            $this->BaseCurrencyCode = $baseCurrencyCode;
        }
        return $this;
    }
    /**
     * Get CurrencyRates value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\CurrencyRates|null
     */
    public function getCurrencyRates()
    {
        return isset($this->CurrencyRates) ? $this->CurrencyRates : null;
    }
    /**
     * Set CurrencyRates value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\StructType\CurrencyRates $currencyRates
     * @return \App|C\StructType\TicketAmountDetails
     */
    public function setCurrencyRates(\App|C\StructType\CurrencyRates $currencyRates = null)
    {
        if (is_null($currencyRates) || (is_array($currencyRates) && empty($currencyRates))) {
            unset($this->CurrencyRates);
        } else {
            $this->CurrencyRates = $currencyRates;
        }
        return $this;
    }
    /**
     * Get FareCalculation value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getFareCalculation()
    {
        return isset($this->FareCalculation) ? $this->FareCalculation : null;
    }
    /**
     * Set FareCalculation value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $fareCalculation
     * @return \App|C\StructType\TicketAmountDetails
     */
    public function setFareCalculation($fareCalculation = null)
    {
        // validation for constraint: string
        if (!is_null($fareCalculation) && !is_string($fareCalculation)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($fareCalculation, true), gettype($fareCalculation)), __LINE__);
        }
        if (is_null($fareCalculation) || (is_array($fareCalculation) && empty($fareCalculation))) {
            unset($this->FareCalculation);
        } else {
            $this->FareCalculation = $fareCalculation;
        }
        return $this;
    }
    /**
     * Get FareCurrencyCode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getFareCurrencyCode()
    {
        return isset($this->FareCurrencyCode) ? $this->FareCurrencyCode : null;
    }
    /**
     * Set FareCurrencyCode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $fareCurrencyCode
     * @return \App|C\StructType\TicketAmountDetails
     */
    public function setFareCurrencyCode($fareCurrencyCode = null)
    {
        // validation for constraint: string
        if (!is_null($fareCurrencyCode) && !is_string($fareCurrencyCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($fareCurrencyCode, true), gettype($fareCurrencyCode)), __LINE__);
        }
        if (is_null($fareCurrencyCode) || (is_array($fareCurrencyCode) && empty($fareCurrencyCode))) {
            unset($this->FareCurrencyCode);
        } else {
            $this->FareCurrencyCode = $fareCurrencyCode;
        }
        return $this;
    }
    /**
     * Get Endorsement value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getEndorsement()
    {
        return isset($this->Endorsement) ? $this->Endorsement : null;
    }
    /**
     * Set Endorsement value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $endorsement
     * @return \App|C\StructType\TicketAmountDetails
     */
    public function setEndorsement($endorsement = null)
    {
        // validation for constraint: string
        if (!is_null($endorsement) && !is_string($endorsement)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($endorsement, true), gettype($endorsement)), __LINE__);
        }
        if (is_null($endorsement) || (is_array($endorsement) && empty($endorsement))) {
            unset($this->Endorsement);
        } else {
            $this->Endorsement = $endorsement;
        }
        return $this;
    }
    /**
     * Get HasBaseCurrency value
     * @return bool|null
     */
    public function getHasBaseCurrency()
    {
        return $this->HasBaseCurrency;
    }
    /**
     * Set HasBaseCurrency value
     * @param bool $hasBaseCurrency
     * @return \App|C\StructType\TicketAmountDetails
     */
    public function setHasBaseCurrency($hasBaseCurrency = null)
    {
        // validation for constraint: boolean
        if (!is_null($hasBaseCurrency) && !is_bool($hasBaseCurrency)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($hasBaseCurrency, true), gettype($hasBaseCurrency)), __LINE__);
        }
        $this->HasBaseCurrency = $hasBaseCurrency;
        return $this;
    }
    /**
     * Get HasNUCCurrency value
     * @return bool|null
     */
    public function getHasNUCCurrency()
    {
        return $this->HasNUCCurrency;
    }
    /**
     * Set HasNUCCurrency value
     * @param bool $hasNUCCurrency
     * @return \App|C\StructType\TicketAmountDetails
     */
    public function setHasNUCCurrency($hasNUCCurrency = null)
    {
        // validation for constraint: boolean
        if (!is_null($hasNUCCurrency) && !is_bool($hasNUCCurrency)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($hasNUCCurrency, true), gettype($hasNUCCurrency)), __LINE__);
        }
        $this->HasNUCCurrency = $hasNUCCurrency;
        return $this;
    }
    /**
     * Get AdditionalCollectionInfo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\AdditionalCollectionInfo|null
     */
    public function getAdditionalCollectionInfo()
    {
        return isset($this->AdditionalCollectionInfo) ? $this->AdditionalCollectionInfo : null;
    }
    /**
     * Set AdditionalCollectionInfo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\StructType\AdditionalCollectionInfo $additionalCollectionInfo
     * @return \App|C\StructType\TicketAmountDetails
     */
    public function setAdditionalCollectionInfo(\App|C\StructType\AdditionalCollectionInfo $additionalCollectionInfo = null)
    {
        if (is_null($additionalCollectionInfo) || (is_array($additionalCollectionInfo) && empty($additionalCollectionInfo))) {
            unset($this->AdditionalCollectionInfo);
        } else {
            $this->AdditionalCollectionInfo = $additionalCollectionInfo;
        }
        return $this;
    }
}
